program NulRead;

{$DEFINE DisableUTF8RTL}
{ $DEFINE DOS}
{ $DEFINE X86_64}
{ $DEFINE LINUX_32}
{ $DEFINE LINUX_64}
{$IFDEF LINUX_32} {$DEFINE LINUX} {$ENDIF}
{$IFDEF LINUX_64} {$DEFINE LINUX} {$ENDIF}
{$IFNDEF LINUX} {$IFNDEF DOS} {$DEFINE WIN_3264} {$ENDIF} {$ENDIF}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}
{$IFNDEF X86_64} {$DEFINE NOBUNK} {$ENDIF}

USES NullUtil, Stdio, Zeit, Dict20, CRT, DOS;

CONST VERSION_INFO = 'NulRead   NULLDISK   V 2.88 ' +
{$IFDEF LINUX_32} '(Linux 32)' {$ELSE} {$IFDEF LINUX_64} '(Linux 64)' {$ELSE}
{$IFDEF DOS}      '(16bit)' {$ELSE}
{$IFDEF X86_64}   '(64bit)' {$ELSE} '(32bit)' {$ENDIF} {$ENDIF} {$ENDIF}
{$ENDIF} + ' 13.01.2021   (c) ALFWARE B.Schubert';

CONST SLASH = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF} ;

CONST PROTO_NULREAD = {$IFDEF DOS} 'rd' {$ELSE} 'nulread' {$ENDIF};

LABEL anz_ende;

procedure Hilfe;
begin
   Writeln;
   Writeln('Aufruf: NulRead [beginn] [anzahl] [loeschen] [verzeichnis] [protokoll]');
   Writeln;
   Writeln('beginn    kleinster Index fuer Dateien Nnnnnnnn.NUL     Werte: 0, [1] - 9999999');
   Writeln;
   Writeln('anzahl    Dateien/Wiederholungen ab "beginn"            Werte: [1] - 9999999');
   Writeln;
   Writeln('loeschen  Sollen Dateien automatisch geloescht werden?  Werte: [N(ein)] / J(a)');
   Writeln('':63,'A(lle)');
   Writeln;
   Writeln('verzeichnis fuer die Dateien (Standard: Aktuelles)      Werte: am besten leer!');
   Writeln;
   Writeln('protokoll schreibt Protokoll mit max n Eintraegen       Werte: [0] - 9999');
   Writeln;
   Writeln('Beispiel: NulRead 3 10 J');
   Writeln('liest Dateien N0000003.NUL - N0000012.NUL, werden anschliessend geloescht');
   Writeln;
   Writeln('Beispiel: NulRead');
   Writeln('liest alle Dateien N0000000.NUL - N9999999.NUL, sofern vorhanden');
   Writeln('Es wird anschliessend geloescht und es werden max 200 Durchlaeufe protokolliert');
   Halt;
end;

procedure Plausi;
Label plausi_ende;
begin
   if ParamCount = 0 then begin
      BEGINN:=0; ANZAHL:=9999999+1; ENDE:= BEGINN + ANZAHL-1;
      LEISE:=false; LOESCHEN:='A'; SCHRITTE:=200; goto plausi_ende;
   end;
   KETTE:=ParamStr(1);
   if (KETTE = '/?') or (KETTE = '-?') or (KETTE = '?') or (KETTE = '/h') or (KETTE = '-h') then Hilfe;
   if KETTE = '' then KETTE:= '1';
   Val(KETTE, BEGINN, c);
   if (c <> 0) or (BEGINN < 0) or (BEGINN > 9999999) then Hilfe;
   KETTE:=Paramstr(2);
   if KETTE = '' then KETTE:= '1';
   Val(KETTE, ANZAHL, c);
   if (c <> 0) or (ANZAHL < 1) or (ANZAHL + BEGINN > 9999999+1) then Hilfe;
   ENDE:=BEGINN + ANZAHL-1;
   KETTE:=ParamStr(3);
   if KETTE <> '' then begin;
      LOESCHEN:=upcase(KETTE [1]);
      if NOT (LOESCHEN in ['J','A']) then LOESCHEN:= 'N';
   end
   else LOESCHEN:= 'N';
   VERZEICHNIS:='';
   KETTE:=ParamStr(4);
   if (KETTE = '') or (KETTE = '*') or (KETTE = '.') or (KETTE = '..') or (KETTE = '\')
      then VERZEICHNIS:=''
      else begin
         VERZEICHNIS:=KETTE;
         if VERZEICHNIS[length(VERZEICHNIS)] <> '\' then VERZEICHNIS:=VERZEICHNIS + '\';
      end;
   KETTE:=Paramstr(5);
   if KETTE = ''
      then KETTE:= '0'
      else BEGIN LEISE:=false; SCHRITTE_AN:=true; end;
   Val(KETTE, SCHRITTE, c);
   if (c <> 0) then SCHRITTE:=200;
   if (SCHRITTE < 0) or (SCHRITTE > 9999) then Hilfe;
plausi_ende:
   if (SCHRITTE < 1) or not Frei_Protokoll then PROTO_AUS:=false;
   Writeln;
   Writeln('BEGINN      = ', Str0long(BEGINN,8), ' -> DATEI-VON=', 'N' + Str0long(BEGINN,7) + '.NUL');
   Writeln('ANZAHL      = ', Str0long(ANZAHL,8), ' -> DATEI-BIS=', 'N' + Str0long(ENDE,7) + '.NUL');
   Writeln('LOESCHEN    = ', LOESCHEN);
   if VERZEICHNIS <> '' then Writeln('VERZEICHNIS = ', VERZEICHNIS);
end;

procedure Analyse;
begin
   for f:=1 to GROESSE_W do begin;
      Inc(ANALYSE_ALLE); Inc(ANALYSE_FELD[ Ord( FELD[f] ) ]);
   end;
end;
procedure Ausgabe_Analyse;
var za: LongInt;
begin
   Write('Zeichen: ');
   ANZAHL_VERS:=0; za:=0;
   for f:=0 to 255 do begin;
      if ANALYSE_FELD[f] > 0 then begin;
         za:= za + Length( str0long( ANALYSE_FELD[f],0 ) ) + 6;
         if za > 76 then begin;
            Writeln; za:=0;
         end;
         inc(ANZAHL_VERS);
         Write(ANALYSE_FELD[f], 'x');
         case f of
            0 : Write('HEX ');
            32: Write('LEER ');
            else Write('#', f ,' ');
         end;
      end;
   end;
   if ANALYSE_ALLE > ANALYSE_MAX then ANALYSE_MAX:=ANALYSE_ALLE;
   WriteLn; Write('Anzahl:  ', ANALYSE_ALLE, ' - Verschiedene: ', ANZAHL_VERS, '  - ');
   if (ANZAHL_VERS > 1) and (ANZAHL_VERS <> 256) then begin
      WriteLn; Write('!!! ACHTUNG FEHLER !!!  ');
               Write('falsche Zeichen in Datei N' + Str0long(EXT,7) + '.NUL', '   >');
      if not LEISE then taste0; WriteLn;
   end;
end;

begin
   ClrScr; Writeln(VERSION_INFO);
   Writeln; Writeln('Liest und analysiert die Dateien von NulWrite...');
   KETTE:=''; BEGINN:=1; ANZAHL:=1; LOESCHEN:='N'; {$IFDEF X86_64} dummy00:=''; {$ENDIF}
   GROESSE_ZEIGE:=0; GROESSE_RECHEN:=0; GROESSE_ANZAHL:=0;
   GROESSE_W:=0; GROESSE_PLUS:=0; OK:=0; Datei_NR:=0; DATEI_ANZAHL:=0; ANALYSE_MAX:=0;
   ZEILE_MAGIC:=0;

   Start_Verzeichnis('nulldisk');
   Plausi;
   Dateien_Vorhanden; DATEI_ANZAHL:=PLATTE_VOLL;

   DATEI_NR:=1;
   Loop_Dir(1);
   Dict_Renum;

   NULL_ZEIT:=Intervall_Start(1);
   Check_Protokoll_AUS;
   if PROTO_AUS then begin
      Protokoll_Name(PROTO_NULREAD);
      Assign(PROTOKOLL, PROTO_VERZEICHNIS + PROTO_NAME); {$I-} Rewrite(PROTOKOLL); {$I+}
      Writeln(PROTOKOLL, NULL_ZEIT); Intervall_Start(3); Intervall_Start(4);
      Writeln(PROTOKOLL);
   end;
   Writeln; WriteLn('Beende mit Tastendruck...');
   AUS:=0; DATEI_NR:=1; LAST:=BEGINN-1;
   if PROTO_AUS then Bestimme_Schritte_Protokoll;

   if DATEI_ANZAHL < 1 then goto anz_ende;
   repeat
      Dict_FindValue(DATEI_NR, EXT);
      if (EXT < BEGINN) or (EXT >= BEGINN + ANZAHL) then INC(DATEI_NR)
      else begin;
         ANALYSE_ALLE:=0; for f:=0 to 255 do ANALYSE_FELD[f]:=0;
         Intervall_Start(2);
         Assign(DATEI, VERZEICHNIS + 'N'+ Str0long(EXT,7) + '.NUL');
         {$I-} Reset(DATEI, 1); {$I+}
         if IOResult <> 0 then inc(DATEI_NR)
         else begin;
            WriteLn;
            repeat

               BlockRead(DATEI, FELD, MAX, GROESSE_W);

               Analyse;

               GROESSE_PLUS:= GROESSE_PLUS + MAX;
               Ausgabe_Megabyte;

            until (EOF(DATEI)) or KeyPressed;
            if ZEILE_MAGIC > 0 then WriteLn;
            Ausgabe_Analyse;

            if EOF(DATEI)
               then begin Ausgabe_Summe; inc(DATEI_NR); end
               else DATEI_NR:= DATEI_ANZAHL + 1;

            if keypressed then begin inc(OK); Writeln; end;
            Close(DATEI);

         end;
      end;
   until DATEI_NR > DATEI_ANZAHL;

anz_ende:
   Dict_Clear;
   NULL_ZEIT:=Intervall_Stop(1);
   if PROTO_AUS then begin
      Writeln(PROTOKOLL);
      Writeln(PROTOKOLL, NULL_ZEIT + '   ' + Intervall_Dauer(1) + '   Gesamtzeit');
      if (OK < 1) and (DATEI_ANZAHL > 0) then OK:=1; 
      if OK=0
         then durchschnitt:=0
         else durchschnitt:=Diff_Moment.rsekunde / OK;
      Writeln(PROTOKOLL);
      Writeln(PROTOKOLL, 'Durchschnittlich: ', durchschnitt: {$IFDEF X86_64} 4:3 {$ELSE} 3:2 {$ENDIF},
                         ' sek pro ', Str0Giga(ANALYSE_MAX), ' Datei (', OK , ')');
      Close(PROTOKOLL);
   end;
   Loeschen_Alle;
   if PROTO_AUS then Zeige_Protokoll;
   if not NULL_STOP then Writeln; Writeln('NulRead ist beendet.   ' + Intervall_Dauer(1));
end (* NulRead *).
