UNIT Dict20; (* Version 2.2  (c) ALFWARE Bernd Schubert *)

{ NUR EINS SETZEN!!! }
{$DEFINE KEY_II}
{ $DEFINE KEY_SS}
{ $DEFINE KEY_SI}
{ $DEFINE KEY_IS}

{$DEFINE DisableUTF8RTL}
{ $DEFINE DOS}
{ $DEFINE X86_64}
{ $DEFINE LINUX_32}
{ $DEFINE LINUX_64}
{$IFDEF LINUX_32} {$DEFINE LINUX} {$ENDIF}
{$IFDEF LINUX_64} {$DEFINE LINUX} {$ENDIF}
{$IFNDEF LINUX} {$IFNDEF DOS} {$DEFINE WIN_3264} {$ENDIF} {$ENDIF}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

INTERFACE

TYPE I_SCHLUESSEL = LONGINT;
     S_SCHLUESSEL = {$IFDEF DOS} STRING[80] {$ELSE} STRING {$ENDIF};
     K_SCHLUESSEL = {$IFDEF KEY_II} I_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_SS} S_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_SI} S_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_IS} I_SCHLUESSEL {$ENDIF};
     V_SCHLUESSEL = {$IFDEF KEY_II} I_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_SS} S_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_SI} I_SCHLUESSEL {$ENDIF}
                    {$IFDEF KEY_IS} S_SCHLUESSEL {$ENDIF};

TYPE mySTRING = {$IFDEF WIN_3264} TYPE AnsiString(850) {$ELSE} STRING {$ENDIF};

(* die allgemeinen Dict-Funktionen funktionieren auf: siehe KEY_kv *)

PROCEDURE Dict_Add       (key:        K_SCHLUESSEL;
                          value:      V_SCHLUESSEL);
PROCEDURE Dict_Inc       (key:        K_SCHLUESSEL);
PROCEDURE Dict_IncX      (key:        K_SCHLUESSEL;
                          value:      V_SCHLUESSEL);
FUNCTION  Dict_Find      (key:        K_SCHLUESSEL;
                          VAR  value: V_SCHLUESSEL) : BOOLEAN;
FUNCTION  Dict_FindValue (value:      V_SCHLUESSEL;
                          VAR  key:   K_SCHLUESSEL) : BOOLEAN;
FUNCTION  Dict_Delete    (key:        K_SCHLUESSEL) : BOOLEAN;
PROCEDURE Dict_Clear;
FUNCTION  Dict_Count                                : LONGINT;
PROCEDURE Dict_Liste;
PROCEDURE Dict_ListeC    (c: CHAR);
PROCEDURE Dict_SplitSave (zeile: STRING);
PROCEDURE Dict_SplitLong (zeile: mySTRING);
PROCEDURE Dict_Renum;

(* II_Dict Funktionen funktionieren auf (LONGINT, LONGINT)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_II_Add       (nr: INTEGER; key:        I_SCHLUESSEL;
                                          value:      I_SCHLUESSEL);
PROCEDURE Dict_II_Inc       (nr: INTEGER; key:        I_SCHLUESSEL);
PROCEDURE Dict_II_IncX      (nr: INTEGER; key:        I_SCHLUESSEL;
                                          value:      I_SCHLUESSEL);
FUNCTION  Dict_II_Find      (nr: INTEGER; key:        I_SCHLUESSEL;
                                          VAR  value: I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_II_FindValue (nr: INTEGER; value:      I_SCHLUESSEL;
                                          VAR  key:   I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_II_Delete    (nr: INTEGER; key:        I_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_II_Clear     (nr: INTEGER);
FUNCTION  Dict_II_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_II_Liste     (nr: INTEGER);
PROCEDURE Dict_II_Renum     (nr: INTEGER);

(* SS_Dict Funktionen funktionieren auf (STRING, STRING)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_SS_Add       (nr: INTEGER; key:        S_SCHLUESSEL;
                                          value:      S_SCHLUESSEL);
FUNCTION  Dict_SS_Find      (nr: INTEGER; key:        S_SCHLUESSEL;
                                          VAR  value: S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SS_FindValue (nr: INTEGER; value:      S_SCHLUESSEL;
                                          VAR  key:   S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SS_Delete    (nr: INTEGER; key:        S_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_SS_Clear     (nr: INTEGER);
FUNCTION  Dict_SS_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_SS_Liste     (nr: INTEGER);

(* SI_Dict Funktionen funktionieren auf (STRING, LONGINT)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_SI_Add       (nr: INTEGER; key:        S_SCHLUESSEL;
                                          value:      I_SCHLUESSEL);
PROCEDURE Dict_SI_Inc       (nr: INTEGER; key:        S_SCHLUESSEL);
PROCEDURE Dict_SI_IncX      (nr: INTEGER; key:        S_SCHLUESSEL;
                                          value:      I_SCHLUESSEL);
FUNCTION  Dict_SI_Find      (nr: INTEGER; key:        S_SCHLUESSEL;
                                          VAR  value: I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SI_FindValue (nr: INTEGER; value:      I_SCHLUESSEL;
                                          VAR  key:   S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_SI_Delete    (nr: INTEGER; key:        S_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_SI_Clear     (nr: INTEGER);
FUNCTION  Dict_SI_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_SI_Liste     (nr: INTEGER);
PROCEDURE Dict_SI_ListeC    (nr: INTEGER; c:          CHAR);
PROCEDURE Dict_SI_SplitSave (nr: INTEGER; zeile:      STRING);
PROCEDURE Dict_SI_SplitLong (nr: INTEGER; zeile:      mySTRING);
PROCEDURE Dict_SI_Renum     (nr: INTEGER);

(* IS_Dict Funktionen funktionieren auf (LONGINT, STRING)
   nr sollte nur 1..10 verwendet werden                   *)

PROCEDURE Dict_IS_Add       (nr: INTEGER; key:        I_SCHLUESSEL;
                                          value:      S_SCHLUESSEL);
FUNCTION  Dict_IS_Find      (nr: INTEGER; key:        I_SCHLUESSEL;
                                          VAR  value: S_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_IS_FindValue (nr: INTEGER; value:      S_SCHLUESSEL;
                                          VAR  key:   I_SCHLUESSEL): BOOLEAN;
FUNCTION  Dict_IS_Delete    (nr: INTEGER; key:        I_SCHLUESSEL) :BOOLEAN;
PROCEDURE Dict_IS_Clear     (nr: INTEGER);
FUNCTION  Dict_IS_Count     (nr: INTEGER)                           :LONGINT;
PROCEDURE Dict_IS_Liste     (nr: INTEGER);

PROCEDURE Heap_Info;

IMPLEMENTATION

USES Stdio;

TYPE  II_ZEIGER = ^II_SATZ;
      II_SATZ = RECORD
         key:    I_SCHLUESSEL;
         value:  I_SCHLUESSEL;
         link:   II_ZEIGER;
      END;

      II_DICT_TYPE = RECORD
         anzahl, aktuell, suche : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch : II_ZEIGER;
      END;

      SS_ZEIGER = ^SS_SATZ;
      SS_SATZ = RECORD
         key:    S_SCHLUESSEL;
         value:  S_SCHLUESSEL;
         link:   SS_ZEIGER;
      END;

      SS_DICT_TYPE = RECORD
         anzahl, aktuell, suche : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch : SS_ZEIGER;
      END;

TYPE  SI_ZEIGER = ^SI_SATZ;
      SI_SATZ = RECORD
         key:    S_SCHLUESSEL;
         value:  I_SCHLUESSEL;
         link:   SI_ZEIGER;
      END;

      SI_DICT_TYPE = RECORD
         anzahl, aktuell, suche : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch : SI_ZEIGER;
      END;

      IS_ZEIGER = ^IS_SATZ;
      IS_SATZ = RECORD
         key:    I_SCHLUESSEL;
         value:  S_SCHLUESSEL;
         link:   IS_ZEIGER;
      END;

      IS_DICT_TYPE = RECORD
         anzahl, aktuell, suche : LONGINT;
         anker, ende, akt, pos, hilfe, vorher, loesch : IS_ZEIGER;
      END;

VAR II_dict: ARRAY[0..10] OF II_DICT_TYPE;
    SS_dict: ARRAY[0..10] OF SS_DICT_TYPE;
    SI_dict: ARRAY[0..10] OF SI_DICT_TYPE;
    IS_dict: ARRAY[0..10] OF IS_DICT_TYPE;

{$IFNDEF DOS} HeapStatusFPC: TFPCHeapStatus; {$ENDIF}

PROCEDURE II_Show2(akt: II_ZEIGER);
BEGIN
   IF akt<>NIL
      THEN WriteLN('Key: ', akt^.key, ', Value: ', akt^.value,', size= ',sizeof(akt^))
      ELSE WriteLN('LEER (NIL)');
END;

PROCEDURE II_Show(akt: II_ZEIGER);
BEGIN
   IF akt<>NIL
      THEN WriteLN('Key: ', akt^.key, ', Value: ', akt^.value)
      ELSE WriteLN('LEER (NIL)');
END;

PROCEDURE II_Analyse(nr: INTEGER);
BEGIN
   WITH II_dict[nr] DO BEGIN
      WriteLn('Nr=',nr,' anzahl=',anzahl, ' aktuell=',aktuell, ' suche=',suche);
      Write('Anker  '); II_Show(anker);
      Write('Ende   '); II_Show(ende);
      Write('Akt    '); II_Show(akt);
      Write('Pos    '); II_Show(pos);
      Write('Hilfe  '); II_Show(hilfe);
      Write('Vorher '); II_Show(vorher);
      Write('Loesch '); II_Show(loesch);
   END;
END;

PROCEDURE Dict_II_Upd(nr: INTEGER; key: I_SCHLUESSEL; value: I_SCHLUESSEL; neu: BOOLEAN);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  IF neu THEN anker^.value:=0;
                  Inc(anker^.value, value);
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  IF neu THEN ende^.value:=0;
                  Inc(ende^.value, value);
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               IF neu THEN pos^.value:=0;
               Inc(pos^.value, value);
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
   END;
   {II_Analyse(nr);}
END;

PROCEDURE Dict_II_Add(nr: INTEGER; key: I_SCHLUESSEL; value: I_SCHLUESSEL);
BEGIN
   Dict_II_Upd(nr, key, value, true);
END;

PROCEDURE Dict_II_IncX(nr: INTEGER; key: I_SCHLUESSEL; value: I_SCHLUESSEL);
BEGIN
   Dict_II_Upd(nr, key, value, false);
END;

PROCEDURE Dict_II_Inc(nr: INTEGER; key: I_SCHLUESSEL);
BEGIN
   Dict_II_IncX(nr, key, 1);
END;

PROCEDURE Dict_II_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         II_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_II_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_II_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_II_Count:=anzahl;
   END;
END;

FUNCTION Dict_II_Find(nr: INTEGER; key: I_SCHLUESSEL; VAR value: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=-1; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_II_Find:=gefunden;
END;

FUNCTION Dict_II_FindValue(nr: INTEGER; value: I_SCHLUESSEL; VAR key: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=-1; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_II_FindValue:=gefunden;
END;

FUNCTION Dict_II_Delete(nr: INTEGER; key: I_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: I_SCHLUESSEL;
BEGIN
   ok:= False;
   IF Dict_II_Find(nr, key, dummy) THEN WITH II_dict[nr] DO BEGIN
      IF loesch = anker
         (* es wird am Anfang gelscht *)
         THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE

         ELSE
            IF loesch = ende
              (* es wird am Ende gelscht *)
              THEN BEGIN vorher^.link:=NIL; ende:=vorher; END

              (* es wird mittendrin gelscht, weil <> anker und <> ende *)
              ELSE vorher^.link:=loesch^.link;

      (* loesch ist jetzt ausgehngt *)
      IF loesch = anker
         THEN Dict_II_Clear(nr)
         ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
      ok:= True;
   END;
   {II_Analyse(nr);}
   Dict_II_Delete:=ok;
END;

PROCEDURE Dict_II_Renum(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH II_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt^.value:=anzahl;
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE SS_Show(akt: SS_ZEIGER);
BEGIN
   WriteLN('Key: ', akt^.key, ', Value: ', akt^.value);
END;

PROCEDURE Dict_SS_Add(nr: INTEGER; key: S_SCHLUESSEL; value: S_SCHLUESSEL);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  anker^.value:=akt^.value;
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  ende^.value:=akt^.value;
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               pos^.value:=akt^.value;
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
   END;
END;

PROCEDURE Dict_SS_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         SS_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_SS_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_SS_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_SS_Count:=anzahl;
   END;
END;

FUNCTION Dict_SS_Find(nr: INTEGER; key: S_SCHLUESSEL; VAR value: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_SS_Find:=gefunden;
END;

FUNCTION Dict_SS_FindValue(nr: INTEGER; value: S_SCHLUESSEL; VAR key: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_SS_FindValue:=gefunden;
END;

FUNCTION Dict_SS_Delete(nr: INTEGER; key: S_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: S_SCHLUESSEL;
BEGIN
   ok:= False;
   IF Dict_SS_Find(nr, key, dummy) THEN WITH SS_dict[nr] DO BEGIN
      IF loesch = anker
         (* es wird am Anfang gelscht *)
         THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE

         ELSE
            IF loesch = ende
              (* es wird am Ende gelscht *)
              THEN BEGIN vorher^.link:=NIL; ende:=vorher; END

              (* es wird mittendrin gelscht, weil <> anker und <> ende *)
              ELSE vorher^.link:=loesch^.link;

      (* loesch ist jetzt ausgehngt *)
      IF loesch = anker
         THEN Dict_SS_Clear(nr)
         ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
      ok:= True;
   END;
   Dict_SS_Delete:=ok;
END;

PROCEDURE SI_Show(akt: SI_ZEIGER);
BEGIN
   WriteLN('Key: ', akt^.key, ', Value: ', akt^.value);
END;

PROCEDURE SI_ShowC(akt: SI_ZEIGER; c: CHAR);
BEGIN
   WriteLN(akt^.key, c, akt^.value);
END;

PROCEDURE Dict_SI_Upd(nr: INTEGER; key: S_SCHLUESSEL; value: I_SCHLUESSEL; neu: BOOLEAN);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  IF neu THEN anker^.value:=0;
                  Inc(anker^.value, value);
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  IF neu THEN ende^.value:=0;
                  Inc(ende^.value, value);
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               IF neu THEN pos^.value:=0;
               Inc(pos^.value, value);
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
   END;
END;

PROCEDURE Dict_SI_Add(nr: INTEGER; key: S_SCHLUESSEL; value: I_SCHLUESSEL);
BEGIN
   Dict_SI_Upd(nr, key, value, true);
END;

PROCEDURE Dict_SI_IncX(nr: INTEGER; key: S_SCHLUESSEL; value: I_SCHLUESSEL);
BEGIN
   Dict_SI_Upd(nr, key, value, false);
END;

PROCEDURE Dict_SI_Inc(nr: INTEGER; key: S_SCHLUESSEL);
BEGIN
   Dict_SI_IncX(nr, key, 1);
END;

PROCEDURE Dict_SI_ListeC(nr: INTEGER; c: CHAR);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         SI_ShowC(akt, c);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_SI_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         SI_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_SI_Wort(nr: INTEGER; VAR wort: STRING);
BEGIN
   IF LENGTH(wort) > 0 THEN BEGIN
      Dict_SI_Inc(nr, wort);
      wort:='';
   END;
END;

PROCEDURE Dict_SI_SplitLong(nr: INTEGER; zeile: mySTRING);
VAR wort: string;
    i: INTEGER;
    c: CHAR;
BEGIN
   wort:='';
   FOR i:=1 TO LENGTH(zeile) DO BEGIN
      c:=zeile[i];
      IF c <> ' '
         THEN wort:= wort + c
         ELSE Dict_SI_Wort(nr, wort);
   END;
   Dict_SI_Wort(nr, wort);
END;

PROCEDURE Dict_SI_SplitSave(nr: INTEGER; zeile: STRING);
VAR temp: mystring;
BEGIN
   temp:=zeile;
   Dict_SI_SplitLong(nr, temp);
END;

PROCEDURE Dict_SI_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_SI_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_SI_Count:=anzahl;
   END;
END;

FUNCTION Dict_SI_Find(nr: INTEGER; key: S_SCHLUESSEL; VAR value: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=0; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_SI_Find:=gefunden;
END;

FUNCTION Dict_SI_FindValue(nr: INTEGER; value: I_SCHLUESSEL; VAR key: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_SI_FindValue:=gefunden;
END;

FUNCTION Dict_SI_Delete(nr: INTEGER; key: S_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: I_SCHLUESSEL;
BEGIN
   ok:= False;
   IF Dict_SI_Find(nr, key, dummy) THEN WITH SI_dict[nr] DO BEGIN
      IF loesch = anker
         (* es wird am Anfang gelscht *)
         THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE

         ELSE
            IF loesch = ende
              (* es wird am Ende gelscht *)
              THEN BEGIN vorher^.link:=NIL; ende:=vorher; END

              (* es wird mittendrin gelscht, weil <> anker und <> ende *)
              ELSE vorher^.link:=loesch^.link;

      (* loesch ist jetzt ausgehngt *)
      IF loesch = anker
         THEN Dict_SI_Clear(nr)
         ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
      ok:= True;
   END;
   Dict_SI_Delete:=ok;
END;

PROCEDURE Dict_SI_Renum(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH SI_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt^.value:=anzahl;
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE IS_Show(akt: IS_ZEIGER);
BEGIN
   WriteLN('Key: ', akt^.key, ', Value: ', akt^.value);
END;

PROCEDURE Dict_IS_Add(nr: INTEGER; key: I_SCHLUESSEL; value: S_SCHLUESSEL);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      INC(anzahl); INC(aktuell);
      NEW(akt);
      akt^.key:=key;
      akt^.value:=value;
      akt^.link:=NIL;

      (* Liste noch leer *)
      IF anker=NIL THEN BEGIN
         anker:=akt; ende:=akt;
      END

      (* eventuell vorne einfgen? *)
      ELSE
         IF key <= anker^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = anker^.key
               THEN BEGIN
                  anker^.value:=akt^.value;
                  Dispose(akt); akt:=anker;
               END
            (* ansonsten davor einfgen *)
               ELSE BEGIN
                  akt^.link:=anker;
                  anker:=akt;
               END
         END

      (* oder hinten anhngen? *)
      ELSE
         IF key >= ende^.key THEN BEGIN
            (* wenn vorhanden, nur updaten *)
            IF key = ende^.key
               THEN BEGIN
                  ende^.value:=akt^.value;
                  Dispose(akt); akt:=ende;
               END
            (* ansonsten hinten anhngen *)
               ELSE BEGIN
                  ende^.link:=akt;
                  ende:=akt;
               END
         END

      (* oder mittendrin einfgen? *)
      ELSE BEGIN
         pos:=anker; hilfe:=pos^.link;
         WHILE(hilfe^.key <= key) DO BEGIN
            INC(suche);
            pos:=pos^.link;
            hilfe:=pos^.link;
         END;
         (* wenn vorhanden, nur updaten *)
         IF key = pos^.key
            THEN  BEGIN
               pos^.value:=akt^.value;
               Dispose(akt); akt:=pos;
            END
         (* ansonsten mittendrin einfgen *)
            ELSE BEGIN
               akt^.link:=pos^.link;
               pos^.link:=akt;
            END
      END;
   END;
END;

PROCEDURE Dict_IS_Liste(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      akt:=anker;
      WHILE akt<>NIL DO BEGIN
         IS_Show(akt);
         akt:=akt^.link;
      END;
   END;
END;

PROCEDURE Dict_IS_Clear(nr: INTEGER);
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      WHILE anker<>NIL DO BEGIN
         akt:=anker; anker:=anker^.link;
         Dispose(akt);
      END;
      anker:=NIL; ende:=NIL; akt:=NIL; pos:=NIL; hilfe:=NIL;
      vorher:=NIL; loesch:=NIL; anzahl:=0; aktuell:=0;
   END;
END;

FUNCTION Dict_IS_Count(nr: INTEGER): LONGINT;
BEGIN
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      akt:=anker;
      anzahl:=0;
      WHILE akt<>NIL DO BEGIN
         INC(anzahl);
         akt:=akt^.link;
      END;
      Dict_IS_Count:=anzahl;
   END;
END;

FUNCTION Dict_IS_Find(nr: INTEGER; key: I_SCHLUESSEL; VAR value: S_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   value:=''; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF key = akt^.key
            THEN BEGIN
               gefunden:=True;
               loesch:=akt;
               value:=akt^.value;
            END
            ELSE vorher:=akt;
         akt:=akt^.link;
      END;
   END;
   Dict_IS_Find:=gefunden;
END;

FUNCTION Dict_IS_FindValue(nr: INTEGER; value: S_SCHLUESSEL; VAR key: I_SCHLUESSEL): BOOLEAN;
VAR gefunden: BOOLEAN;
BEGIN
   key:=0; gefunden:=False;
   IF NOT nr IN [1..10] THEN nr:=0;
   WITH IS_dict[nr] DO BEGIN
      akt:=anker; loesch:=NIL; vorher:=NIL;
      WHILE (akt<>NIL) AND NOT gefunden DO BEGIN
         IF value = akt^.value THEN BEGIN
            gefunden:=True;
            key:=akt^.key;
         END;
         akt:=akt^.link;
      END;
   END;
   Dict_IS_FindValue:=gefunden;
END;

FUNCTION Dict_IS_Delete(nr: INTEGER; key: I_SCHLUESSEL): BOOLEAN;
VAR ok: BOOLEAN;
    dummy: S_SCHLUESSEL;
BEGIN
   ok:= False;
   IF Dict_IS_Find(nr, key, dummy) THEN WITH IS_dict[nr] DO BEGIN
      IF loesch = anker
         (* es wird am Anfang gelscht *)
         THEN
            (* es sind noch weitere Eintrge da *)
            IF loesch^.link <> NIL THEN anker:=loesch^.link ELSE

         ELSE
            IF loesch = ende
              (* es wird am Ende gelscht *)
              THEN BEGIN vorher^.link:=NIL; ende:=vorher; END

              (* es wird mittendrin gelscht, weil <> anker und <> ende *)
              ELSE vorher^.link:=loesch^.link;

      (* loesch ist jetzt ausgehngt *)
      IF loesch = anker
         THEN Dict_IS_Clear(nr)
         ELSE BEGIN Dispose(loesch); DEC(anzahl); END;
      ok:= True;
   END;
   Dict_IS_Delete:=ok;
END;

PROCEDURE Heap_Info;
VAR memovoll: LONGINT;
BEGIN
   {$IFDEF DOS} WriteLN('HEAP    Speicher frei: ' + StrCardInt(MEMAVAIL));
   {$ELSE}
   HeapStatusFPC:=GetFPCHeapStatus;
   memovoll:=HeapStatusFPC.CurrHeapUsed;
   WriteLN('HEAP    Speicher max:  ' + StrCardInt(HeapStatusFPC.MaxHeapUsed)
                                 + '/' + StrCardInt(HeapStatusFPC.MaxHeapSize));
   WriteLN('HEAP    Speicher frei: ' + StrCardInt(HeapStatusFPC.CurrHeapFree)
                                 + '/' + StrCardInt(HeapStatusFPC.CurrHeapSize));
   WriteLN('HEAP    Speicher voll: ' + StrCardInt(memovoll));
   {$ENDIF}
END;

PROCEDURE Dict_Add(key: K_SCHLUESSEL; value: V_SCHLUESSEL);
BEGIN
   {$IFDEF KEY_II} Dict_II_Add(0, key, value); {$ENDIF};
   {$IFDEF KEY_SS} Dict_SS_Add(0, key, value); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_Add(0, key, value); {$ENDIF};
   {$IFDEF KEY_IS} Dict_IS_Add(0, key, value); {$ENDIF};
END;

PROCEDURE Dict_Inc(key: K_SCHLUESSEL);
BEGIN
   {$IFDEF KEY_II} Dict_II_Inc(0, key); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_Inc(0, key); {$ENDIF};
END;

PROCEDURE Dict_IncX(key: K_SCHLUESSEL; value: V_SCHLUESSEL);
BEGIN
   {$IFDEF KEY_II} Dict_II_IncX(0, key, value); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_IncX(0, key, value); {$ENDIF};
END;

PROCEDURE Dict_Liste;
BEGIN
   {$IFDEF KEY_II} Dict_II_Liste(0); {$ENDIF};
   {$IFDEF KEY_SS} Dict_SS_Liste(0); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_Liste(0); {$ENDIF};
   {$IFDEF KEY_IS} Dict_IS_Liste(0); {$ENDIF};
END;

PROCEDURE Dict_ListeC(c: CHAR);
BEGIN
   {$IFDEF KEY_SI} Dict_SI_ListeC(0, c); {$ENDIF};
END;

PROCEDURE Dict_SplitSave(zeile: STRING);
BEGIN
   {$IFDEF KEY_SI} Dict_SI_SplitSave(0, zeile); {$ENDIF};
END;

PROCEDURE Dict_SplitLong(zeile: mySTRING);
BEGIN
   {$IFDEF KEY_SI} Dict_SI_SplitLong(0, zeile); {$ENDIF};
END;

PROCEDURE Dict_Clear;
BEGIN
   {$IFDEF KEY_II} Dict_II_Clear(0); {$ENDIF};
   {$IFDEF KEY_SS} Dict_SS_Clear(0); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_Clear(0); {$ENDIF};
   {$IFDEF KEY_IS} Dict_IS_Clear(0); {$ENDIF};
END;

FUNCTION Dict_Count: LONGINT;
BEGIN
   {$IFDEF KEY_II} Dict_Count:=Dict_II_Count(0); {$ENDIF};
   {$IFDEF KEY_SS} Dict_Count:=Dict_SS_Count(0); {$ENDIF};
   {$IFDEF KEY_SI} Dict_Count:=Dict_SI_Count(0); {$ENDIF};
   {$IFDEF KEY_IS} Dict_Count:=Dict_IS_Count(0); {$ENDIF};
END;

FUNCTION Dict_Find(key: K_SCHLUESSEL; VAR value: V_SCHLUESSEL):BOOLEAN;
BEGIN
   {$IFDEF KEY_II} Dict_Find:=Dict_II_Find(0, key, value); {$ENDIF};
   {$IFDEF KEY_SS} Dict_Find:=Dict_SS_Find(0, key, value); {$ENDIF};
   {$IFDEF KEY_SI} Dict_Find:=Dict_SI_Find(0, key, value); {$ENDIF};
   {$IFDEF KEY_IS} Dict_Find:=Dict_IS_Find(0, key, value); {$ENDIF};
END;

FUNCTION Dict_FindValue(value: V_SCHLUESSEL; VAR key: K_SCHLUESSEL):BOOLEAN;
BEGIN
   {$IFDEF KEY_II} Dict_FindValue:=Dict_II_FindValue(0, value, key); {$ENDIF};
   {$IFDEF KEY_SS} Dict_FindValue:=Dict_SS_FindValue(0, value, key); {$ENDIF};
   {$IFDEF KEY_SI} Dict_FindValue:=Dict_SI_FindValue(0, value, key); {$ENDIF};
   {$IFDEF KEY_IS} Dict_FindValue:=Dict_IS_FindValue(0, value, key); {$ENDIF};
END;

FUNCTION Dict_Delete(key: K_SCHLUESSEL):BOOLEAN;
BEGIN
   {$IFDEF KEY_II} Dict_Delete:=Dict_II_Delete(0, key); {$ENDIF};
   {$IFDEF KEY_SS} Dict_Delete:=Dict_SS_Delete(0, key); {$ENDIF};
   {$IFDEF KEY_SI} Dict_Delete:=Dict_SI_Delete(0, key); {$ENDIF};
   {$IFDEF KEY_IS} Dict_Delete:=Dict_IS_Delete(0, key); {$ENDIF};
END;

PROCEDURE Dict_Renum;
BEGIN
   {$IFDEF KEY_II} Dict_II_Renum(0); {$ENDIF};
   {$IFDEF KEY_SI} Dict_SI_Renum(0); {$ENDIF};
END;

BEGIN
   Dict_II_Clear(0);
   Dict_SS_Clear(0);
   Dict_SI_Clear(0);
   Dict_IS_Clear(0);

END (* Dict20 *).
