unit NullUtil;

{$DEFINE DisableUTF8RTL}
{ $DEFINE DOS}
{ $DEFINE X86_64}
{ $DEFINE LINUX_32}
{ $DEFINE LINUX_64}
{$IFDEF LINUX_32} {$DEFINE LINUX} {$ENDIF}
{$IFDEF LINUX_64} {$DEFINE LINUX} {$ENDIF}
{$IFNDEF LINUX} {$IFNDEF DOS} {$DEFINE WIN_3264} {$ENDIF} {$ENDIF}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}
{$IFNDEF x86_64} {$DEFINE NOBUNK} {$ENDIF}

interface

uses Stdio, Dict20, Zeit, CRT, DOS
     {$IFDEF X86_64}, SysUtils
     {$ELSE}
     {$ENDIF} ;

const SLASH = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF} ;

const MAX = 32768;
      PROTO_NAME        : String = 'nullnull';
      PROTO_VERZEICHNIS : String = '';
      PROTO_AUS         : boolean = true;
      PROTO_HOME        : integer = 0;
      DATEN_HOME        : integer = 0;
      SCHRITTE          : longint = 200;
      SCHRITTE_AN       : boolean = false;
      NULL_STOP         : boolean = false;
      LEISE             : boolean = true;

var   io_verzeichnis, io                                    : integer;
      erghome, io_bw                                        : boolean;
      PROTOKOLL                                             : Text;
      DATEI                                                 : File;
      ZEICHEN, LOESCHEN, ZUFALL, CH                         : Char;
      VERZEICHNIS, KETTE, ZEILE, NULL_ZEIT                  : String;
      {$IFDEF X86_64} dummy00                               : String; {$ENDIF}
      GROESSE_KRUMM                                         : Real;
      GROESSE, ZEILE_MAGIC, GROESSE_ZEIGE, GROESSE_RECHEN,
      GROESSE_AKTUELL, GROESSE_LAENGE, GROESSE_ANZAHL,
      GROESSE_PLUS, GROESSE_ALLE,
      GROESSE_PROTO_WRITE, GROESSE_PROTO_OPEN,
      PLATTE_FREI, {PLATTE_GESAMT,} PLATTE_PLAN,
      PLATTE_VOLL, PLATTE_ANZAHL, PLATTE_SCHRITT,
      DATEI_ANZAHL, DATEI_NR,
      ANALYSE_ALLE, ANALYSE_MAX                             : CardInt;
      OK, EXT, BEGINN, ANZAHL, ENDE, AUS, LAST              : Longint;
      GROESSE_W, GROESSE_AKT, ANZAHL_VERS,
      f, g, gg, c                                           : Word;
      FELD                                                  : array[1..MAX] of Char;
      ANALYSE_FELD                                          : ARRAY[0..255] of longint;
      durchschnitt                                          : double;
      Dirinfo                               {$IFDEF X86_64} : TSearchRec;
                                                    {$ELSE} : SearchRec;
                                                    {$ENDIF}

procedure Start_Verzeichnis(name: string);
procedure Protokoll_Name(pre: string);

procedure Loop_Dir(funktion: integer);

procedure Datentraeger_Frei;
procedure Dateien_Vorhanden;
procedure Bestimme_Schritte_Protokoll;

procedure Ausgabe_Megabyte;

procedure Make_Directory(REST,PFAD: string);
procedure Delete_Directory(REST,PFAD: string);
procedure Loeschen_Alle;

procedure Ausgabe_Summe;
procedure Zeige_Protokoll;
function Frei_Protokoll: boolean;
procedure Check_Protokoll_AUS;

IMPLEMENTATION

var homedir : string;
(*  i       : integer; *)

procedure Loop_Innen(funktion: integer);
begin
   KETTE:=copy(DirInfo.Name, 2, 7);
   val(KETTE, EXT, c);
   case funktion of
    1: begin
          if (BEGINN <= EXT) and (EXT <= ENDE) then begin
	     Dict_Add(EXT, DATEI_NR);
             Inc(DATEI_NR);
          end;
       end;
    2: begin
          if (BEGINN <= EXT) and (EXT <= ENDE) then inc(PLATTE_VOLL);
       end;
    3: begin
          Write(DirInfo.Name);
          if ((BEGINN <= EXT) and (EXT <= ENDE)) or (LOESCHEN = 'A') then begin
             Assign(DATEI, VERZEICHNIS + DirInfo.Name);
             {$I-} Erase(DATEI); {$I+}
             if IOResult = 0
                then Writeln(' geloescht')
                else Writeln(' Fehler!!!');
          end
          else Writeln(' uebersprungen');
       end;
    else ;
   end;
end;

function Loop_Bedingung(funktion: integer):boolean;
begin
   case funktion of
    1:   Loop_Bedingung:=(DATEI_NR <= DATEI_ANZAHL);
    2:   Loop_Bedingung:=true;
    3:   Loop_Bedingung:=true;
    else Loop_Bedingung:=false;
   end;
end;

procedure Loop_Dir(funktion: integer);
begin
   {$IFDEF X86_64}
   if FindFirst(VERZEICHNIS + 'N*' + '.NUL', faAnyFile, Dirinfo) = 0 then begin
      repeat
         Loop_Innen( funktion );
      until (FindNext(Dirinfo) <> 0) or (not Loop_Bedingung(funktion));
      FindClose(DirInfo);
   end;
   {$ELSE}
   FindFirst(VERZEICHNIS + 'N*' + '.NUL', AnyFile, DirInfo);
   while (DosError = 0) and Loop_Bedingung( funktion ) do begin
      Loop_Innen( funktion );
      FindNext(DirInfo);
   end;
   {$IFNDEF DOS} FindClose(DirInfo); {$ENDIF}
   {$ENDIF}
end;

procedure Protokoll_Name(pre: string);
{$IFDEF DOS} var maxnummer, nummer: cardint; {$ENDIF}
begin
   {$IFDEF DOS}
   maxnummer:=0;
   FindFirst(PROTO_VERZEICHNIS + pre + '*' + '.TXT', AnyFile, DirInfo);
   while (DosError = 0) do begin
      KETTE:=copy(DirInfo.Name, 3, 6);
      val(KETTE, nummer, c);
      if (c = 0) and (nummer > maxnummer) then maxnummer:=nummer;
      FindNext(DirInfo);
   end;
   PROTO_NAME:=pre + str0long(maxnummer + 1, 6) + '.txt';
   {$ELSE}
   Steche_Moment; Formate_Moment(Akt_Moment);
   PROTO_NAME:=pre + '_' +copy(Formate.FileStampDT, 1, 17) + '.txt';
   {$ENDIF}
END;

procedure Check_Verzeichnis(name: string);
begin
   if PROTO_VERZEICHNIS <> '' then PROTO_VERZEICHNIS:= PROTO_VERZEICHNIS + SLASH;
   PROTO_VERZEICHNIS:= PROTO_VERZEICHNIS + name;
   if erghome then WriteLn('check: ', PROTO_VERZEICHNIS);
   {$i-} ChDir(PROTO_VERZEICHNIS); io:= ioresult; {$i+}
   if erghome then WriteLn('Ioresult chdir: ', io);
   if io <> 0 then begin
      {$i-} MkDir(PROTO_VERZEICHNIS); io:= ioresult; {$I+}
      if erghome then WriteLn('Ioresult mkdir: ', io);
   end;
   if io = 0 then io_verzeichnis:= 0;
   if erghome then WriteLn('io check: ', io_verzeichnis);
   PROTO_VERZEICHNIS:= PROTO_VERZEICHNIS + SLASH;
   {$i-} ChDir(homedir); io:= ioresult; {$I+}
   if erghome then WriteLn('Ioresult reset home chdir ' + homedir + ': ', io);
end;

procedure Start_Verzeichnis(name: string);
begin
   GetDir(0,homedir); PROTO_VERZEICHNIS:= ''; io_verzeichnis:= -1; io:= -1;

   {$IFNDEF DOS}
      {$IFDEF LINUX} PROTO_VERZEICHNIS:= GetEnv('HOME');
      {$ELSE} PROTO_VERZEICHNIS:= GetEnv('homedrive') + GetEnv('homepath'); {$ENDIF}
      if PROTO_VERZEICHNIS <> '' then check_Verzeichnis(name);
   {$ENDIF}

   if io_verzeichnis <> 0 then begin
      PROTO_VERZEICHNIS:= GetEnv('temp');
      if PROTO_VERZEICHNIS <> '' then check_Verzeichnis(name);
   end;

   if io_verzeichnis <> 0 then begin
      PROTO_VERZEICHNIS:= GetEnv('tmp');
      IF PROTO_VERZEICHNIS <> '' THEN check_Verzeichnis(name);
   end;

   if io_verzeichnis <> 0 then begin
      PROTO_VERZEICHNIS:= '';
      check_verzeichnis(name);
   end;
end;

procedure Datentraeger_Frei;
begin
   PLATTE_FREI:=diskfree(DATEN_HOME);
   {PLATTE_GESAMT:=disksize(0);}
   if PLATTE_FREI > 0
       then PLATTE_VOLL:=PLATTE_FREI div GROESSE
       else PLATTE_VOLL:=0;
end;

procedure Dateien_Vorhanden;
begin
   PLATTE_VOLL:=0;
   Loop_Dir(2);
end;

procedure Bestimme_Schritte_Protokoll;
begin
   if PLATTE_VOLL < ANZAHL
      then PLATTE_ANZAHL:=PLATTE_VOLL
      else PLATTE_ANZAHL:=ANZAHL;
   if (PLATTE_ANZAHL > 1) and (PLATTE_ANZAHL <= SCHRITTE)
      then PLATTE_SCHRITT:=1
      else begin
         if PLATTE_ANZAHL <> 1
            then PLATTE_PLAN:=PLATTE_ANZAHL+SCHRITTE
            else PLATTE_PLAN:=PLATTE_VOLL;
         PLATTE_SCHRITT:=PLATTE_PLAN div SCHRITTE;
      end;
   if PLATTE_SCHRITT < 1 then PLATTE_SCHRITT:=1;
end;

procedure Ausgabe_Megabyte;
begin
   GROESSE_RECHEN:=GROESSE_PLUS DIV MEGA;
   if GROESSE_RECHEN > GROESSE_ZEIGE then begin;
      GROESSE_AKTUELL:=GROESSE_ANZAHL*KILO + GROESSE_RECHEN;

      GROESSE_LAENGE:=Length( str0long( GROESSE_AKTUELL,0) );
      if ZEILE_MAGIC + GROESSE_LAENGE > 76 then begin;
         WriteLn; ZEILE_MAGIC:=0;
      end;
      Inc(ZEILE_MAGIC , GROESSE_LAENGE+3);

      Write(GROESSE_AKTUELL, 'M, ');
      null_stop:=false;
      GROESSE_ZEIGE:=GROESSE_RECHEN;
      if GROESSE_RECHEN > KILO then begin;
         GROESSE_PLUS:=GROESSE_PLUS - GIGA;
         GROESSE_ZEIGE:=GROESSE_ZEIGE - KILO;
         inc(GROESSE_ANZAHL);
      end;
   end;
end;

procedure Ausgabe_Summe;
begin
   Intervall_Stop(2);
   Writeln('N' + Str0long(EXT,7) + '.NUL', ' ok   ', Intervall_Dauer(2));
   Check_Protokoll_AUS;
   if PROTO_AUS then begin
      Intervall_Stop(3); Intervall_Dauer(3);
      if (diff_moment.rminute > 1.0) then begin
         Close(PROTOKOLL); Append(PROTOKOLL);
         Intervall_Start(3);
      end;
      inc(AUS);
      if (AUS <= 10) or (DATEI_ANZAHL - AUS <= 10) or (AUS MOD PLATTE_SCHRITT = 0) then begin
         if GROESSE_ALLE >= 50*MEGA then Writeln('Schreibe Protokoll');
         Intervall_Stop(2);
         Write(PROTOKOLL, 'Next: ' + Formate.TimeStamp + '   ' +
                          Intervall_Dauer(2) + '   N' + Str0long(EXT,7) + '.NUL' + ' ok');
         Intervall_Stop(4);
         if (LAST < 0) or (EXT - LAST < 2)
            then Writeln(PROTOKOLL)
            else Writeln(PROTOKOLL, '   ' + Intervall_Dauer(4) + ' Gruppe (' + Str0long(EXT-LAST, 0) + ')');
         LAST:=EXT;
         Intervall_Start(4);
      end;
   end;
   inc(OK); ZEILE_MAGIC:=0;
end;

procedure Ausgabe_Zeile(ZEILE: string; var i: integer);
begin
   Writeln(copy(ZEILE, 1, 68)); inc(i);
   if length(ZEILE) > 68 then begin
       Writeln('':{$IFDEF X86_64} 30 {$ELSE} 31 {$ENDIF}, copy(ZEILE, 70, length(ZEILE)-69)); inc(i);
   end;
end;

procedure Zeige_Protokoll;
var i:integer;
begin
   {$i-} Reset(PROTOKOLL); io:=ioresult; {$i+}
   if io = 0
      then begin
         readln(PROTOKOLL, ZEILE); i:=1;
         Writeln; Writeln('Zusammenfassung:'); Writeln;
         while not EOF(PROTOKOLL) do begin
            if (i mod 25 = 0) and not LEISE then begin
               Write('Weiter mit Taste >'); taste0; Writeln;
            end;
            Ausgabe_Zeile(ZEILE, i);
            readln(PROTOKOLL, ZEILE);
         end;
         Ausgabe_Zeile(ZEILE, i);
         Close(PROTOKOLL);
         Writeln; Writeln('Diese Liste steht auch unter:');
         Writeln(PROTO_VERZEICHNIS + PROTO_NAME);
   end;
end;

{$IFDEF DOS}
function DosPfad(PFAD: string):string;
begin
   DosPfad:=PFAD;
   if PFAD[length(PFAD)]='\' then DosPfad:=copy(PFAD,1,length(PFAD)-1);
end;
{$ENDIF}

procedure Make_Directory(REST,PFAD: string);
var P:integer;
begin
   P:=pos('\',REST);
   if P = 0
      then begin
         PFAD:=PFAD+REST+'\'; REST:='';
      end
      else begin
         PFAD:=PFAD+copy(REST,1,P); REST:=copy(REST,P+1,255)
      end;
   {$IFDEF DOS}
      {$I-} MkDir(DosPfad(PFAD)); {$I+}
   {$ELSE}
      {$I-} MkDir(PFAD); {$I+}
   {$ENDIF}
   if IOResult = 0 then Writeln('Verzeichnis: ',PFAD,' angelegt');
   if REST <> '' then Make_Directory(REST,PFAD);
end;

procedure Delete_Directory(REST,PFAD: string);
var P,I,J:integer;
begin
   P:=0; I:=Length(REST); J:=I;
   while I > 0 do begin
      if (REST[I] = '\') and (J > I)
         then begin P:=I; I:=0; end;
      dec(I);
   end;
   PFAD:=REST;
   if P = 0
      then REST:=''
      else REST:=copy(REST,1,P-1);
   {$IFDEF DOS}
      {$I-} RmDir(DosPfad(PFAD)); {$I+}
   {$ELSE}
      {$I-} RmDir(PFAD); {$I+}
   {$ENDIF}
   if IOResult = 0 then Writeln('Verzeichnis: ',PFAD,' geloescht');
   if REST <> '' then Delete_Directory(REST,PFAD);
end;

procedure Loeschen_Alle;
begin
   if (LOESCHEN <> 'N') and not KeyPressed then begin;
      Writeln; Write('Weiter mit beliebiger Taste, zum Loeschen der Dateien >');
      if not LEISE then taste0; Writeln;

      Loop_Dir(3);

      if VERZEICHNIS <> '' then Delete_Directory(VERZEICHNIS,'');
   end;
end;

function Gleiches_Laufwerk: boolean;
var c1, c2: char;

begin
   GetDir(0,homedir); c1:=' '; c2:=' ';
   if VERZEICHNIS <> ''
      then c1:=UpCase( VERZEICHNIS[1] )
      else c1:=UpCase( homedir[1] );
   if PROTO_VERZEICHNIS <> '' then c2:=UpCase( PROTO_VERZEICHNIS[1] );
   Gleiches_Laufwerk:= (c1=c2) and not SCHRITTE_AN;
end;

function GetAnzLW: integer;
var i, anz: integer;
    home: string;
begin
   {$IFDEF LINUX}
   GetAnzLw:=1;
   {$ELSE}
   anz:=0;
   PROTO_HOME:=-1;
   for i:=0 to 30 do if (i<>1) and (i<>2) then begin
      GetDir(i, home);
      if DiskFree(i) > 0 then begin
         if UpCase(home[1]) = UpCase(PROTO_VERZEICHNIS[1]) then
            if PROTO_HOME < 0 then PROTO_HOME:=i;
         if i > 0 then INC(anz);
      end;
   end;
   GetAnzLW:=anz;
   {$ENDIF}

end;

function Frei_Protokoll: boolean;
var frei: boolean;
begin
   frei:=false;
   GROESSE_PROTO_WRITE:=0;
   GROESSE_PROTO_OPEN:=0;
   if GetAnzLW < 2  (* Linux oder Windows nur 1 Festplatte *)
      then begin
         GROESSE_PROTO_WRITE:= {$IFDEF LINUX} {MEGA} 50*KILO {$ELSE} 30*KILO {$ENDIF} ;
         GROESSE_PROTO_OPEN:=20*KILO;
         if PROTO_HOME < 0 then PROTO_HOME:=0;
         frei:=true;
      end
      else frei:=not Gleiches_Laufwerk;
   Frei_Protokoll:=frei;
end;

procedure Check_Protokoll_AUS;
begin
   if PROTO_AUS then begin
      if diskfree(PROTO_HOME) < GROESSE_PROTO_OPEN then PROTO_AUS:=false;
   end; 
end;

begin
   (* GetDir(0,homedir); *)
   erghome:=FALSE;

(* Writeln('Umgebungsvariablen:');
   for i:= 1 to EnvCount do
      WriteLn(EnvStr(i));
   WriteLn; *)

end (* NullUtil *).
